-- JoomlaPack 1.3
-- Copyright (c)2006-2008 JoomlaPack Developers. All Rights Reserved.
-- License: GNU/GPL version 2, or later
--
-- JoomlaPack tables definition for JP1.3 / MySQL 4.1+
--

-- Backup profiles table
CREATE TABLE IF NOT EXISTS `#__jp_profiles` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `description` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`)
);
INSERT IGNORE INTO `#__jp_profiles` (`id`,`description`) VALUES (1,'Default Backup Profile');

-- Exclusion filters table
CREATE TABLE IF NOT EXISTS `#__jp_exclusion` (
	`id` bigint(20) NOT NULL auto_increment,
	`profile` int(10) unsigned NOT NULL,
	`class` varchar(255) NOT NULL,
	`value` longtext NOT NULL,
	PRIMARY KEY  (`id`)
); 

-- Inclusion filters table
CREATE TABLE IF NOT EXISTS `#__jp_inclusion` (
	`id` bigint(20) NOT NULL auto_increment,
	`profile` int(10) unsigned NOT NULL,
	`class` varchar(255) NOT NULL,
	`value` longtext NOT NULL,
	PRIMARY KEY  (`id`)
);

-- JoomlaPack Options and Settings Registry table
CREATE TABLE IF NOT EXISTS `#__jp_registry` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `profile` int(10) unsigned NOT NULL default '1',
  `key` varchar(255) NOT NULL,
  `value` longtext NOT NULL,
  PRIMARY KEY  (`id`)
);

-- Temporary data table
CREATE TABLE IF NOT EXISTS `#__jp_temp` (
  `key` varchar(255) NOT NULL,
  `value` longtext NOT NULL,
  PRIMARY KEY  (`key`)
);

-- Statistics table
CREATE TABLE IF NOT EXISTS `#__jp_stats` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `description` varchar(255) NOT NULL,
  `comment` longtext,
  `backupstart` timestamp NOT NULL default '0000-00-00 00:00:00',
  `backupend` timestamp NOT NULL default '0000-00-00 00:00:00',
  `status` enum('run','fail','complete') NOT NULL default 'run',
  `origin` enum('backend','frontend') NOT NULL default 'backend',
  `type` enum('full','dbonly','extradbonly') NOT NULL default 'full',
  `profile_id` bigint(20) NOT NULL default '1',
  `archivename` longtext,
  `absolute_path` longtext,
  PRIMARY KEY  (`id`)
);

-- JoomlaPack Database Tables Patches
--
-- JoomlaPack version ever since 2.0.a1 can upgrade. Therefore, changes to the database
-- schema used are issued as SQL "patches" (ALTER commands) instead of being integrated
-- to the CREATE TABLE commands above

-- Tables patch 2.0.a1 to 2.0.b1 (added 'extradbonly' to the enumeration type)
ALTER TABLE `#__jp_stats` MODIFY COLUMN `type` ENUM('full','dbonly','extradbonly') NOT NULL DEFAULT 'full';