<?php
/**
 * @package JoomlaPack
 * @copyright Copyright (c)2006-2008 JoomlaPack Developers
 * @license GNU General Public License version 2, or later
 * @version $id$
 * @since 1.3
 */

// Protect from unauthorized access
defined('_JEXEC') or die('Restricted Access');

jimport('joomla.application.component.model');

/**
 * The Control Panel model
 *
 */
class JoomlapackModelCpanel extends JModel
{
	/**
	 * Contructor; dummy for now
	 *
	 */
	function __construct()
	{
		parent::__construct();
	}
	
	/**
	 * Get an array of icon definitions for the Control Panel
	 *
	 * @return array
	 */
	function getIconDefinitions()
	{
		$ret = array();

		$ret[] = $this->_makeIconDefinition( 'profiles.png', JText::_('PROFILES'), 'profiles' );
		$ret[] = $this->_makeIconDefinition( 'config.png', JText::_('CONFIGURATION'), 'config' );
		$ret[] = $this->_makeIconDefinition( 'backup.png', JText::_('BACKUP'), 'backup' );
		$ret[] = $this->_makeIconDefinition( 'bufa.png', JText::_('BUADMIN'), 'buadmin' );
		$ret[] = $this->_makeIconDefinition( 'log.png', JText::_('VIEWLOG'), 'log' );
		
		$ret[] = $this->_makeIconDefinition( 'multidb.png', JText::_('MULTIDB'), 'multidb' );
		//$ret[] = $this->_makeIconDefinition( 'extradirs.png', JText::_('EXTRADIRS'), 'extradirs' );
		$ret[] = $this->_makeIconDefinition( 'sff.png', JText::_('SFF'), 'sff' );
		$ret[] = $this->_makeIconDefinition( 'def.png', JText::_('DEF'), 'def' );
		$ret[] = $this->_makeIconDefinition( 'full.png', JText::_('DCS'), 'skip' );
		$ret[] = $this->_makeIconDefinition( 'dbef.png', JText::_('DBEF'), 'dbef' );

		//$ret[] = $this->_makeIconDefinition( 'ftp.png', JText::_('FTPXFERWIZARD'), 'ftpx' );
		//$ret[] = $this->_makeIconDefinition( 'imexset.png', JText::_('IMPORT_EXPORT_SETTINGS'), 'imexset' );

		return $ret;
	}

	/**
	 * Returns a list of available backup profiles, to be consumed by JHTML in order to build
	 * a drop-down
	 *
	 * @return array
	 */
	function getProfilesList()
	{
		$db =& $this->getDBO();
		$query = "SELECT ".$db->nameQuote('id').", ".$db->nameQuote('description').
				" FROM ".$db->nameQuote('#__jp_profiles');
		$db->setQuery($query);
		$rawList = $db->loadAssocList();
		
		$options = array();
		if(!is_array($rawList)) return $options;
		
		foreach($rawList as $row)
		{
			$options[] = JHTML::_('select.option', $row['id'], $row['description']);
		}
		
		return $options;
	}
	
	/**
	 * Returns the active Profile ID
	 *
	 * @return int The active profile ID
	 */
	function getProfileID()
	{
		$session =& JFactory::getSession();
		return $session->get('profile', null, 'joomlapack');
	}
	
	/**
	 * Creates an icon definition entry
	 *
	 * @param string $iconFile The filename of the icon on the GUI button
	 * @param string $label The label below the GUI button
	 * @param string $view The view to fire up when the button is clicked
	 * @return array The icon definition array
	 */
	function _makeIconDefinition($iconFile, $label, $view = null, $task = null )
	{
		return array(
			'icon'	=> $iconFile,
			'label'	=> $label,
			'view'	=> $view,
			'task'	=> $task
		);
	}
}