<?php
/**
 * @package JoomlaPack
 * @copyright Copyright (c)2006-2008 JoomlaPack Developers
 * @license GNU General Public License version 2, or later
 * @version $id$
 * @since 1.3
 */

// Protect from unauthorized access
defined('_JEXEC') or die('Restricted Access');

// Load framework base classes
jimport('joomla.application.component.view');

/**
 * JoomlaPack Control Panel view class
 *
 */
class JoomlapackViewCpanel extends JView 
{
	function display()
	{		
		// Set the toolbar title; add a help button
		JToolBarHelper::title(JText::_('JOOMLAPACK'));
		JToolBarHelper::help('cpanel',true);
		
		// Add submenus (those nifty text links below the toolbar!)
		// -- Configuration
		$link = JURI::base().'?option='.JRequest::getCmd('option').'&view=config';
		JSubMenuHelper::addEntry(JText::_('CONFIGURATION'), $link);
		// -- Backup Now
		$link = JURI::base().'?option='.JRequest::getCmd('option').'&view=backup';
		JSubMenuHelper::addEntry(JText::_('BACKUP'), $link);
		// -- Administer Backup Files
		$link = JURI::base().'?option='.JRequest::getCmd('option').'&view=buadmin';
		JSubMenuHelper::addEntry(JText::_('BUADMIN'), $link);
		
		// Load the helper classes
		$this->loadHelper('utils');
		$this->loadHelper('status');
		$statusHelper = JoomlapackHelperStatus::getInstance();
		
		// Load the model
		jpimport('models.statistics', true);
		$model =& $this->getModel();
		$statmodel = new JoomlapackModelStatistics();
		
		$this->assign('icondefs', $model->getIconDefinitions()); // Icon definitions
		$this->assign('profileid', $model->getProfileID()); // Active profile ID
		$this->assign('profilelist', $model->getProfilesList()); // List of available profiles
		$this->assign('statuscell', $statusHelper->getStatusCell() ); // Backup status
		$this->assign('detailscell', $statusHelper->getQuirksCell() ); // Details (warnings)
		$this->assign('statscell', $statmodel->getLatestBackupDetails() );

		$css = JURI::base().'components/com_joomlapack/assets/css/joomlapack.css';
		$document =& JFactory::getDocument();
		$document->addStyleSheet($css);
		
		parent::display();
	}
}