<?php
/**
 * @package JoomlaPack
 * @copyright Copyright (c)2006-2008 JoomlaPack Developers
 * @license GNU General Public License version 2, or later
 * @version $id$
 * @since 1.3
 */

// Protect from unauthorized access
defined('_JEXEC') or die('Restricted Access');

// Load framework base classes
jimport('joomla.application.component.view');

/**
 * MVC View for Profiles management
 *
 */
class JoomlapackViewStatistics extends JView
{
	function display()
	{
		// Set the toolbar title
		JToolBarHelper::title(JText::_('JOOMLAPACK'));
		
		// Decide what to do; delegate data loading to private methods
		$task = JRequest::getCmd('task','display');
		$layout = JRequest::getCmd('layout','default');
		switch($layout)
		{
			case 'edit':
				switch($task)
				{
					case 'config':
						$helpfile = 'statistics.config';
						$this->_add();
						break;
						
					case 'edit':
						$helpfile = 'profiles.edit';
						$this->_edit();
						break;
				}
				break;
			
			default:
				$helpfile = 'statistics';
				$this->_default();
				break;
		}
		
		// Add a spacer, a help button and show the template
		JToolBarHelper::spacer();
		JToolBarHelper::help($helpfile, true);
		parent::display();
	}
	
	/**
	 * The default layout, shows statistics
	 *
	 */
	function _default()
	{
		// @todo 
	}
	
	/**
	 * The edit layout on an edit task, lets the user delete/clear stats
	 *
	 */
	function _edit()
	{
		// @todo
	}
}