<?php
/**
* @package asv_kalenda
* @version $Id: asv_kalenda.html.php 36 2008-03-26 16:00:05Z denis $
* @copyright Copyright (C) 2007 Denis Willems 
* @author Denis Willems - denis@asveyou.be 
* @link http://www.asveyou.be
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/


defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
 
class kalendaFront {
    /**
     * Static method to create the template object
     * @return patTemplate
     */
    function &createTemplate() {
        global $mosConfig_absolute_path;
        if (file_exists($mosConfig_absolute_path . '/includes/patTemplate/patTemplate.php' ))
			require_once( $mosConfig_absolute_path . '/includes/patTemplate/patTemplate.php' );
		elseif (file_exists($mosConfig_absolute_path . '/plugins/system/legacy/patfactory.php' ))
			//j1.5 legacy
			require_once( $mosConfig_absolute_path . '/plugins/system/legacy/patfactory.php' );		
		
        $tmpl =& patFactory::createTemplate( array(), true, false );
        $tmpl->setRoot( dirname( __FILE__ ) . '/tmpl' );

        return $tmpl;
    }
    /**
    * @desc Transforme une date sql en timestamp
    * @param string chine au format 0000-00-00 00:00:00 ou 0000-00-00
    * @return timestamp
    */
    function DatetimeFromSql($s){
        if (ereg( "([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})", $s, $regs ))
            return mktime($regs[4], $regs[5], $regs[6],$regs[2], $regs[3], $regs[1]);
        elseif (ereg( "([0-9]{4})-([0-9]{2})-([0-9]{2})", $s, $regs ))
            return mktime(0,0,0,$regs[2], $regs[3], $regs[1]);
        else
            return false;
    }
 /**
    * @desc Transforme 2 timestamps en chane "du...au" ou 1 timestamp en "le..."
    *       Si l'heure est 00:00:00, ne l'indique pas
    * @param timestamp 
    * @param timestamp
    * @return string
    */
    function formatDuAu($date1, $date2=null, $du=KALENDA_FROM_D, $au=KALENDA_TO_D, $de=KALENDA_FROM_H, $a=KALENDA_TO_H, $le=KALENDA_BEFORE_DATE){
        $date1=kalendaFront::DatetimeFromSql($date1);
		$date1_has_time=(strftime('%H%M%S', $date1)!='000000');
        $date2=kalendaFront::DatetimeFromSql($date2);
		
        //une seule date    --- ne plus utiliser strftime ? car system-dependant %#d = %e
        if (empty($date2) or $date2<$date1){
			          
            if ($date1_has_time) $masque="$le %#d %B %y $a %Hh%M";
            else $masque="$le %#d %B %y";
            return strftime($masque, $date1);
		}
		//une seule date, deux heures
		elseif (strftime('%d%m%y', $date1)==strftime('%d%m%y', $date2)) 
            return strftime("$le %#d %B %y $de %Hh%M $a ", $date1).strftime("%Hh%M", $date2);
        else $date2_has_time=(strftime('%H%M%S', $date2)!='000000');
		
        //meme mois meme anne
        if (strftime('%m%y', $date1)==strftime('%m%y', $date2))
            return strftime(($date1_has_time?"$du %#d ($a %Hh%M) ":"$du %#d "),$date1).
            strftime(($date2_has_time?"$au %#d %B %y ($a %Hh%M) ":"$au %#d %B %y"),$date2);
        //meme anne
        elseif (strftime('%y', $date1)==strftime('%y', $date2))
            return strftime(($date1_has_time?"$du %#d %B ($a %Hh%M) ":"$du %#d %B "),$date1).
            strftime(($date2_has_time?"$au %#d %B %y ($a %Hh%M) ":"$au %#d %B %y"),$date2);
        //autre
        else
            return strftime(($date1_has_time?"$du %#d %B %y ($a %Hh%M)":"$du %#d %B %y"),$date1).
            strftime(($date2_has_time?" $au %#d %B %y ($a %Hh%M) ":" $au %#d %B %y"),$date2);
    }
 /**
    * @desc affiche la liste des vnements
    */
	function listEvents($rows, $tmpl_file='liste_moo.html', $params=null) { 

       global $mosConfig_live_site;
        $tmpl =& kalendaFront::createTemplate();
				if(_ISO=='charset=utf-8') $tmpl_file=str_replace('.html','-utf8.html',$tmpl_file); //grossier mais efficace dans ce cas...
        $tmpl->readTemplatesFromInput( $tmpl_file );
        $tmpl->addGlobalVar( 'com_root',  $mosConfig_live_site."/components/com_asv_kalenda/");
        $tmpl->addGlobalVar( 'root',  $mosConfig_live_site);
        $tmpl->addObject( 'rows', $rows, 'r_' );
        $tmpl->addVar('rows', 'details', $params->get('liste_details',KALENDA_INFO));
        $tmpl->addVar('asv_kalenda_liste', 'titre', $params->get('page_title')?'<h3>'.$params->get('header').'</h3>':'');
        $tmpl->addVar('asv_kalenda_liste', 'label', $params->get('show_label')?'<h3>'.$params->get('header').'</h3>':'');
        if ($params->get('ouvrir_tout')==1)
            $tmpl->addVar('asv_kalenda_liste', 'ouvrir_tout', '1');
        $tmpl->displayParsedTemplate( 'asv_kalenda_liste' ); 
        
    }
    function showEvent($rows) {

       global $mosConfig_live_site, $params, $mainframe;
	   if (empty($rows[0]->description_longue)) $rows[0]->description_longue=$rows[0]->description_courte;
	   if (empty($rows[0]->description_longue)) $rows[0]->description_longue=KALENDA_NOTHING_TO_SHOW;
	   
       foreach($rows as $k=>$r) $rows[$k]->fdate = kalendaFront::formatDuAu($r->debut, $r->fin);
        $tmpl =& kalendaFront::createTemplate();
        if(_ISO=='charset=utf-8') $tmpl->readTemplatesFromInput( 'event-utf8.html' );
		else $tmpl->readTemplatesFromInput( 'event.html' );
        $tmpl->addGlobalVar( 'com_root',  $mosConfig_live_site."/components/com_asv_kalenda/");
        if($mainframe->asvUtils->params->get('tooltips')){
			$tmpl->addVar('event','tooltips',true);
		}
		$tmpl->addObject( 'rows', $rows, 'r_' );
        $tmpl->addObject( 'event',  $rows[0], 'e_' );
        $tmpl->addVar('event', 'test', 'mon test');
        $tmpl->displayParsedTemplate( 'event' ); 
        
        
    }
    
    function calendrier($rows, $month, $year, $option,$params,$filter_cat){
		global $mosConfig_live_site, $mainframe;
		$show_label = mosGetParam( $_REQUEST ,'show_label', $params->get('show_label') );
		$cal = new activeCalendar($year,$month);
	

        $cal->enableMonthNav($mosConfig_live_site."/index.php?option=$option&amp;show_label=$show_label&amp;filter_cat=$filter_cat");//$cal->enableMonthNav([$link,$arrowBack,$arrowForw]);
		$jours=array();
		if($rows) foreach($rows as $k=>$r){
		
		if ($show_label) $r->titre=$r->catlabel.$r->titre;
			if($r->fin){
				$from=(substr($r->debut,5,2)==$month)?substr($r->debut,8,2):1;
				$to=(substr($r->fin,5,2)==$month)?substr($r->fin,8,2):31;
			 }else 
				$from = $to = (int)substr($r->debut,8,2); 
			for ($i=$from; $i<=$to; $i++){
				 if(!isset($jours[$i]->parEvent[$r->id])){ //id was eid !!!
					$jours[$i]->parEvent[$r->id]=true; //id was eid !!!
					
					$link=$mainframe->asvUtils->mkLink("$mosConfig_live_site/index.php?option=com_asv_kalenda&amp;task=view&amp;event_id={$r->id}&amp;souc=0", $r->titre, $r->titre, $r->description_courte, array(), "", true);
					
						$cal->setEventContent($year,$month,$i,$link[4],$link[0],false,'class="'.$link[1].'" title="'.$link[2].'"');
				}
			}
		}	

        include('tmpl/calendrier_moo.php'); 
    
    }
}
?>
