<?php
/*
 * $Id: fmt-external.php 800 2008-04-15 01:57:23Z Fritz Elfert $
 *
 * AllVideos Reloaded for Joomla! 1.5
 *
 * Author: Fritz Elfert
 * Copyright 2007 by Fritz Elfert
 *
 * Inspired by and partially based on:
 *
 *   The "AllVideos" Plugin for Joomla 1.0.x - Version 2.4
 *   Authors: Fotis Evangelou - George Chouliaras
 *   Copyright (c) 2006 JoomlaWorks.gr - http://www.joomlaworks.gr
 */

defined('_JEXEC') or die('Direct Access Is Not Allowed');

/**
 * Pattern definitions for Flash based external players
 */
$formats = array (

    'dmotion' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.dailymotion.com/swf/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','8.0.0',@XPINST@,\n".
        "{v3:'1',related:'0',autoPlay:'@AUTOSTART!d@',".
        "colors:'background:DDDDDD;glow:FFFFFF;foreground:333333;special:FFC300;'},".
        "{wmode:'@WMODE@',bgcolor:'@BGCOLOR@',quality:'high',allowScriptAccess:'allways',allowfullscreen:'true'},".
        "{id:'p_@DIVID@',styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'mega' => array (
        'ripper' => array (
            'url' => 'http://www.megavideo.com/?v=@CODE@',
            'regex' => '#addVariable\s*\(\s*"flv"\s*,\s*"([^"]+)"#',
            'urldecode' => 0,
        ),
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.megavideo.com/mvplayer.swf','@DIVID@','@WIDTH@','@HEIGHT@','8.0.0',@XPINST@,\n".
        "{waitingtime:'0',flv:'@CODE@',poker:'0',v:'@OCODE@',rel_again:'Play again',rel_other:'Related videos',".
        "u:'',user:'',from:'from:',views:'views',vid_time:'00:00',vid_name:'',videoname:''},".
        "{wmode:'@WMODE@',bgcolor:'@BGCOLOR@',quality:'high',allowScriptAccess:'sameDomain'},".
        "{id:'p_@DIVID@',styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'ted' => array (
        'ripper' => array (
            'url' => 'http://www.ted.com/index.php/talks/view/id/@CODE@',
            'regex' => '#firstRun\s*=\s*"([^"]+)"#',
            'urldecode' => 0,
        ),
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.ted.com/swf/videoplayer.swf','@DIVID@','@WIDTH@','@HEIGHT@','8.0.0',@XPINST@,\n".
        "{jsonStr:'@CODE@',flashID:'swfVideoPlayer'},".
        "{wmode:'@WMODE@',bgcolor:'@BGCOLOR@',quality:'high',allowScriptAccess:'always'},".
        "{id:'p_@DIVID@',styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'ted2' => array (
        'ripper' => array (
            'url' => 'http://www.ted.com/index.php/talks/view/id/@CODE@',
            'regex' => '#paste-->.+&file=([^&]+).*</object>#',
            'urldecode' => 0,
        ),
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://static.videoegg.com/ted/flash/loader.swf','@DIVID@','@WIDTH@','@HEIGHT@','8.0.0',@XPINST@,\n".
        "{file:'@CODE@',autoPlay:'@AUTOSTART@',allowFullscreen:'@USEFULLSCREEN@',forcePlay:'false',logo:'',".
        "fullscreenURL:'http://static.videoegg.com/ted/flash/fullscreen.html'},".
        "{wmode:'@WMODE@',bgcolor:'@BGCOLOR@',quality:'high',allowScriptAccess:'always'},".
        "{id:'p_@DIVID@',styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    '6cn' => array (
        'ripper' => array (
            'url' => 'http://6.cn/watch/@CODE@.html',
            'urldecode' => 0,
            'regex' => "#pageMessage.evid\s*=\s*'([^']+)'\s*;#",
        ),
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://6.cn/player.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{vid:'@CODE@',flag:'1'},{".
        "allowfullscreen:'true',".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'bofunk' => array (
        'ripper' => array (
            'url' => 'http://www.bofunk.com/video/@CODE@.html',
            'urldecode' => 0,
            'regex' => "#<input\stype='text'\svalue='<embed\ssrc=\"([^\"]+)\"#",
        ),
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "allowfullscreen:'true',".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'ifilm' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.ifilm.com/efp','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{flvBaseClip:'@CODE@'},{".
        "name:'efp',".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'youtube' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.youtube.com/v/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{autoplay:'@AUTOSTART!d@',color1:'@PBGCOLOR@',color2:'@PHICOLOR@',rel:'@YTREL!d@',".
        "egm:'@YTEGM!d@',border:'@YTBORDER!d@',loop:'@YTLOOP!d@'},{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'yahoo' => array (
        'ripper' => array (
            'url' => 'http://video.yahoo.com/watch/@CODE@',
            'urldecode' => 0,
            'regex' => '#<link\srel="video_src"\shref="[^\?]+\?onsite=\d&id=(\d+)&#',
        ),
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://d.yimg.com/static.video.yahoo.com/yep/YV_YEP.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{onsite:'0',embed:'1',id:'@CODE@',vid:'@OCODE@'},{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'vimeo' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.vimeo.com/moogaloop.swf?clip_id=@CODE@&server=www.vimeo.com&show_title=1&show_byline=1&show_portrait=0&autoplay=@AUTOSTART!d@&fullscreen=@USEFULLSCREEN!d@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "scale:'showall',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'metacafe' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.metacafe.com/fplayer/@CODE@.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{altServerURL:'http://www.metacafe.com',playerVars:'showStats=no|autoPlay=no|videoTitle='},{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'jumpcut' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.jumpcut.com/media/flash/jump.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{asset_type:'movie',asset_id:'@CODE@',eb:'1'},{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'currenttv' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://current.com/e/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'freevideoblog' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.vidiac.com/vidiac.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{name:'ePlayer',video:'@CODE@'},{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'streetfire' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://videos.streetfire.net/vidiac.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{name:'ePlayer',video:'@CODE@'},{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'stickam' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.stickam.com/flashVarMediaPlayer/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "scale:'noscale',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'myvideo' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.myvideo.de/movie/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'sevenload' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://de.sevenload.com/pl/@CODE@/500x403/swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{apiHost:'api.sevenload.com'},{".
        "wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    /* krazyshow doesnt work anymore...
    <table border="0" cellpadding="0" cellspacing="0"><tr><td align="center"><embed src="http://www.krazyshow.com/media/flvplayer2.swf?autoStart=0&popup=1&video=http%3a%2f%2fwww.krazyshow.com%2fmedia%2fgetflashvideo.ashx%3fcid%3d75E7E6000596439DB819546E2D0521E1" type="application/x-shockwave-flash" quality="high" WIDTH="460" HEIGHT="373"></embed><br/><a target="_new" href="http://www.krazyshow.com/media/playvideo.aspx?cid=75E7E6000596439DB819546E2D0521E1">Replay video</a>&nbsp;|&nbsp;<a target="_new" href="http://www.krazyshow.com/media/playvideo.aspx?cid=75E7E6000596439DB819546E2D0521E1&autoStart=0&email=1#email">Share video</a>&nbsp;|&nbsp;<a target="_new" href="http://www.krazyshow.com">Watch more videos</a></td></tr></table>*/

    'revver' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://flash.revver.com/player/1.0/player.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{mediaId:'@CODE@',".
        "javascriptContext:'true',".
        "skinURL:'http://flash.revver.com/player/1.0/skins/Default_Raster.swf',".
        "skinImgURL:'http://flash.revver.com/player/1.0/skins/night_skin.png',".
        "actionBarSkinURL:'http://flash.revver.com/player/1.0/skins/DefaultNavBarSkin.swf',".
        "resizeVideo:'true'},\n{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'clipfish' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.clipfish.de/videoplayer.swf?videoid=@CODE@&r=1','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'collegehumor' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.collegehumor.com/moogaloop/moogaloop.swf?clip_id=@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'gametrailers' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.gametrailers.com/remote_wrap.php?mid=@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'uume' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.uume.com/v/@CODE@_UUME','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'tudou' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.tudou.com/v/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'seehaha' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.seehaha.com/flash/playvid2.swf?vidID=@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'quxiu' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.quxiu.com/photo/swf/swfobj.swf?id=@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "menu:'false',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'wangyou' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://v.wangyou.com/images/x_player.swf?id=@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'mofile' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://tv.mofile.com/cn/xplayer.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{v:'@CODE@',autoplay:'0'},{".
        "wmode:'@WMODE@',".
        "allowScriptAccess:'always',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'biku' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.biku.com/opus/player.swf?VideoID=@CODE@&embed=true&autoStart=@AUTOSTART@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'break' => array (
        'ripper' => array (
            'url' => 'http://www.break.com/index/@CODE@.html',
            'regex' => '#<param name="movie" value="([^"]+)">#',
            'urldecode' => 0,
        ),
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'virb' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.virb.com/external/video/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "salign:'tl',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),
);
